#******************************************************************************
# vO: P010705.R                                                     *
# eLXg̏: Ṕ@SAS/RpX͎̉                         *
# eLXg̐: V߁@dr                                            *
# gpړI: Steel-Dwasš(mpgbNłTukey̑dr)          *
# Date: 2017/2/3  Version: 1.0                                                *
#******************************************************************************

# ----- o͐ݒ
sink("./p010705.txt")
# ----- Tvf[^荞
d010705.what<-list(group=0, atai=0)
tmp1<-scan(file="./d010705.csv",what=d010705.what,sep="")
d010705<-as.data.frame(tmp1)
# ----- Steel-Dwass̊֐`
usr.steeldwass <- function(group, data)
{
	get.rho <- function(ni)
	{
		k <- length(ni)
		rho <- outer(ni, ni, function(x, y) { sqrt(x/(x+ni[1])*y/(y+ni[1])) })
		diag(rho) <- 0
		sum(rho[-1, -1])/(k-2)/(k-1)
	}
	group <- factor(group)
	assign("ni",table(group),pos=1)
	a <- length(ni) 
	t <- numeric(a*(a-1)/2) 
	g2 <- t 
	g1 <- g2 
	count <- 0
	for (i in 1:(a-1)) {
		control <- data[group == i]
		n1 <- length(control)
		for (j in (i+1):a) {
			rho <- ifelse(sum(n1 == ni) == a, 0.5, get.rho(ni))
			r <- rank(c(data[group == i], data[group == j]))
			R <- sum(r[1:ni[i]])
			N <- ni[i]+ni[j]
			E <- ni[i]*(N+1)/2
			V <- ni[i]*ni[j]/(N*(N-1))*(sum(r^2)-N*(N+1)^2/4)
			count <- count+1
			t[count] <- abs(R-E)/sqrt(V)
			g1[count] <- i
			g2[count] <- j
		}
	}
        p <- ptukey(t*sqrt(2), a, Inf, lower=FALSE)
        result <- cbind(t, p)
        row.names(result) <- paste(g1, g2, sep=":")
        result
}
# ---- Steel-Dwasš(mpgbNłTukey̑dr)
s010705steeldwass<-usr.steeldwass(d010705$group, d010705$atai)
print(s010705steeldwass)
# ----- o͐Wɖ߂
sink()
