#******************************************************************************
# vO: P020205.R                                                     *
# eLXg̏: Q́@SAS/RpX̗ᐔ݌v                     *
# eLXg̐: Q߁@QQ̔r                                      *
# gpړI: 䗦̔򐫋yѓ̗ᐔ߂                          *
# Date: 2021/8/19  Version: 1.1                                               *
#******************************************************************************

# ----- o͐ݒ
sink("./p020205.txt")
# ----- ֐` ----- 䗦̔򐫋yѓ̗ᐔ
#  P        : ʂ̕L
#  DELTA    : 򐫃}[WiEj
#  ALPHA    : БLӐ
#  N1       : ǗᐔiJnj
#  N2       : ǗᐔiIj
#  INTERVAL : ǗᐔiԊuj
f020205<-function(P,DELTA,ALPHA,N1,N2,INTERVAL)
{

	A <- P
	B <- 0.99

	imax <- 0
	if(B<A){
		C <- A
		A <- B
		B <- C
	}

	endsw <- 0
	while(endsw==0){

		fa <- (P-(A-DELTA))/((A-DELTA)*(1-A+DELTA))+(P-A)/(A*(1-A))
		if(fa==0){
			endsw <- 1
			break
		}
		fb <- (P-(B-DELTA))/((B-DELTA)*(1-B+DELTA))+(P-B)/(B*(1-B))
		if(fb==0){
			endsw <- 1
			break
		}
		for (ix in 0:100) {
			C <- (A+B)/2
			if((C-A)<=1.0E-7 | (B-C)<=1.0E-7) {next}

			fc <- (P-(C-DELTA))/((C-DELTA)*(1-C+DELTA))+(P-C)/(C*(1-C))
			if(fc==0) {
				endsw <- 1
				break
			}

			if((fc>0)&(fa>0)) {
			A  <- C
				fa <- fc
			} else {
				B  <- C
				fb <- fc
			}
		}
		break
	}

	PP <- C

	Q  <- 1-P
	QQ <- 1-PP

	IN <- seq(N1,N2,by=INTERVAL)
	INleng <- length(IN)
	power1 <- rep(NA,INleng)
	power2 <- rep(NA,INleng)

	for(ix in seq(1,INleng,by=1)) {
		N <- IN[ix]
		power1[ix] <- pnorm((DELTA*sqrt(N)-1/sqrt(N)-qnorm(1-ALPHA)*sqrt(PP*QQ+(PP-DELTA)*(QQ+DELTA)))/sqrt(2*P*Q))
		power2[ix] <- 2*pnorm((DELTA*sqrt(N)-1/sqrt(N)-qnorm(1-ALPHA)*sqrt(PP*QQ+(PP-DELTA)*(QQ+DELTA)))/sqrt(2*P*Q))-1

	}

	data.frame(P=rep(P,INleng),PP=rep(PP,INleng),DELTA=rep(DELTA,INleng),ALPHA=rep(ALPHA,INleng),
				Q=rep(Q,INleng),QQ=rep(QQ,INleng),N=IN,power1=power1,power2=power2)
}
# ----- vZ
s020205a <- f020205(P=0.75,DELTA=0.1,ALPHA=0.05,N1=200,N2=400,INTERVAL=10)
print(s020205a)
# ----- o͐Wɖ߂
sink()
