#******************************************************************************
# vO: P020302.R                                                     *
# eLXg̏: Q́@SAS/RpX̗ᐔ݌v                     *
# eLXg̐: R߁@pʔ                                        *
# gpړI: Qlf[^i䗦j̗pʔ̗ᐔ߂                    *
# Date: 2017/2/3  Version: 1.0                                                *
#******************************************************************************

# ----- o͐ݒ
sink("./p020302.txt")
# ----- ֐` ----- vl̗pʔ̗ᐔ݌v(Cochran-Armitage)
#  ALPHA  : БLӐ(P̉ߌ)
#  BETA   : 2̉ߌ
#  VALUES : eQ̗Li{,}؂ŗ񋓁j
#         : Q̐{VALUES}̒`苁߂
#  VALUESɒpʁi邢͍pʁj珇ɑzL{,}؂
#  ׂ邱ƂɂAQ̐Ɋ֌WȂKvȗᐔ߂邱Ƃł
f020302 <- function(ALPHA, BETA, VALUES)
{
	Z.ALPHA <- qnorm(1-ALPHA)
	Z.BETA <- qnorm(1-BETA)

	K <- length(VALUES)
	SUM <- sum(VALUES)
	CCPQ <- sum((((1:K) -1) - (K -1)/2) ^2 * VALUES * (1-VALUES))
	CP <- sum((((1:K) -1) - (K-1)/2) * VALUES)
	P <- SUM / K
	Q <- 1-P
	NO <- (((Z.ALPHA*sqrt((K*(K^2-1)*P*Q)/12) + Z.BETA*sqrt(CCPQ)))/CP)^2
	n <- (NO/4)*((1+sqrt(1+2/(NO*CP)))^2)

	c(SUM=SUM,CCPQ=CCPQ,CP=CP,ALPHA=ALPHA,BETA=BETA,K=K,
		Z.ALPHA=Z.ALPHA,Z.BETA=Z.BETA,G=VALUES,P=P,Q=Q,NO=NO,N=n)

}
# ----- vZ
s020302a <- f020302(ALPHA=0.025, BETA=0.2, VALUES=c(0.4,0.6,0.8))
print(s020302a)
# ----- o͐Wɖ߂
sink()
