#******************************************************************************;
# vO: P020501.R                                                     *;
# eLXg̏: Q́@SAS/RpX̗ᐔ݌v                     *;
# eLXg̐: T߁@ԉ                                        *;
# gpړI: ԉ͂ɂėᐔ߂                                  *;
# Date: 2017/2/3  Version: 1.0                                                *;
#******************************************************************************;

# ----- o͐ݒ
sink("./p020501.txt")
# ----- ֐` ----- ԉ̗͂ᐔ݌v
#  R      : 󂯓                                                     */
#  Tr     : ǐՊ                                                         */
#  TIME   : TIMEN                                                     */
#  A      : 100A(%)(<1)                                                */
#  B      : 100B(%)(<1)                                                */
#  ALPHA  : LӐ(<1)                                                     */
#  BETA   : ói1-BETAj                                                 */
#  S      : ᐔ(Na/Nb)                                                    */
f020501 <- function(R, Tr, TIME, A, B, ALPHA, BETA, S)
{
	LA <- -log(A)/TIME
	LB <- -log(B)/TIME
	LBER <- (LA + LB)/2
	QA <- 1/(1 + S)
	QB <- S/(1 + S)
	ZA <- qnorm(1 - ALPHA/2)
	ZB <- qnorm(1 - BETA)
	P00 <- LBER * LBER
	P01 <- LA * LA
	P02 <- LB * LB
	P10 <- LBER^2/(1 -exp(-LBER*Tr))
	P11 <- LA^2/(1-exp(-LA*Tr))
	P12 <- LB^2/(1-exp(-LB*Tr))
	P20 <- LBER^3*Tr/(LBER*Tr-1+exp(-LBER*Tr))
	P21 <- LA^3*Tr/(LA*Tr-1+exp(-LA*Tr))
	P22 <- LB^3*Tr/(LB*Tr-1+exp(-LB*Tr))
	P30 <- LBER^2*(1-(exp(-LBER*(Tr-R))-exp(-LBER*Tr))/(LBER*R))^(-1)
	P31 <- LA^2*(1-(exp(-LA*(Tr-R))-exp(-LA*Tr))/(LA*R))^-1
	P32 <- LB^2*(1-(exp(-LB*(Tr-R))-exp(-LB*Tr))/(LB*R))^-1
	N <- ((ZA*sqrt(P00*(1/QB+1/QA)) + ZB*sqrt(P01/QA+P02/QB))/abs(LA-LB))^2/(1+S)
	M <- ((ZA*sqrt(P10*(1/QB+1/QA)) + ZB*sqrt(P11/QA+P12/QB))/abs(LA-LB))^2/(1+S)
	O <- ((ZA*sqrt(P30*(1/QB+1/QA)) + ZB*sqrt(P31/QA+P32/QB))/abs(LA-LB))^2/(1+S)
	L <- ((ZA*sqrt(P20*(1/QB+1/QA)) + ZB*sqrt(P21/QA+P22/QB))/abs(LA-LB))^2/(1+S)

	c(S=S, 󂯓=R, =TIME, nU[hA=LA, nU[hB=LB, 
		ALPHA=ALPHA, ZA=ZA, BETA=BETA, ZB=ZB, 
		"R=0,T=Inf"=N, "R=0, T>0"=M, "0<R<T"=O, "O<R=T"=L)

}
# ----- vZ
s020501a <- f020501(R=3, T=5, TIME=5, A=0.2, B=0.05, ALPHA=0.05, BETA=0.2, S=1)
print(s020501a)
# ----- o͐Wɖ߂
sink()
